#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2800eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight28004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight28004xi = {
                1:'-1011x-2042y-1626z',
                2:'-1012x-1774y-1914z',
                3:'-1012x-807y-2482z',
                4:'-1027x-258y-2591z',
                5:'-1057x-2585y-195z',
                6:'-105x-936y-2742z',
                7:'-1064x-209y-2581z',
                8:'-1073x-768y-2469z',
                9:'-1099x-157y-2570z',
                10:'-110x-483y-2755z',
                11:'-1114x-1735y-1893z',
                12:'-1124x-2000y-1603z',
                13:'-1132x-101y-2558z',
                14:'-1133x-724y-2455z',
                15:'-1190x-675y-2442z',
                16:'-1192x-2527y-167z',
                17:'-1214x-1690y-1873z',
                18:'-1236x-1952y-1580z',
                19:'-1246x-623y-2428z',
                20:'-1299x-567y-2414z',
                21:'-1312x-1638y-1852z',
                22:'-1323x-2463y-139z',
                23:'-1346x-1897y-1557z',
                24:'-1349x-506y-2400z',
                25:'-1397x-442y-2385z',
                26:'-1409x-1581y-1831z',
                27:'-143x-503y-2750z',
                28:'-1441x-374y-2370z',
                29:'-1451x-2391y-111z',
                30:'-1453x-1836y-1534z',
                31:'-1502x-1518y-1809z',
                32:'-153x-923y-2638z',
                33:'-1557x-1769y-1510z',
                34:'-1575x-2313y-83z',
                35:'-1593x-1449y-1788z',
                36:'-1658x-1696y-1486z',
                37:'-1680x-1375y-1766z',
                38:'-1694x-2228y-55z',
                39:'-1755x-1617y-1463z',
                40:'-1764x-1296y-1744z',
                41:'-178x-521y-2745z',
                42:'-1809x-2136y-27z',
                43:'-1844x-1211y-1722z',
                44:'-1849x-1532y-1439z',
                45:'-187x-1874y-2071z',
                46:'-1918x-2039y0z',
                47:'-1920x-1122y-1700z',
                48:'-1938x-1442y-1415z',
                49:'-1991x-1027y-1678z',
                50:'-201x-2150y-1781z',
                51:'-2022x-1346y-1390z',
                52:'-2057x-929y-1655z',
                53:'-206x-2768y-362z',
                54:'-207x-940y-2629z',
                55:'-2102x-1245y-1366z',
                56:'-2118x-826y-1633z',
                57:'-215x-536y-2739z',
                58:'-2174x-719y-1610z',
                59:'-2176x-1140y-1342z',
                60:'-2224x-608y-1587z',
                61:'-2245x-1030y-1317z',
                62:'-2268x-494y-1564z',
                63:'-2307x-377y-1541z',
                64:'-2308x-916y-1292z',
                65:'-2338x-258y-1517z',
                66:'-2365x-798y-1267z',
                67:'-2416x-676y-1242z',
                68:'-2460x-552y-1217z',
                69:'-254x-549y-2733z',
                70:'-262x-953y-2619z',
                71:'-27x-411y-2769z',
                72:'-288x-1882y-2052z',
                73:'-295x-559y-2727z',
                74:'-316x-2154y-1760z',
                75:'-320x-962y-2609z',
                76:'-338x-566y-2721z',
                77:'-351x-2757y-334z',
                78:'-380x-969y-2599z',
                79:'-383x-570y-2714z',
                80:'-390x-1884y-2033z',
                81:'-428x-571y-2707z',
                82:'-431x-2152y-1738z',
                83:'-441x-971y-2588z',
                84:'-475x-569y-2700z',
                85:'-493x-1881y-2014z',
                86:'-495x-2738y-306z',
                87:'-503x-969y-2577z',
                88:'-522x-563y-2692z',
                89:'-52x-437y-2765z',
                90:'-548x-2143y-1716z',
                91:'-566x-964y-2566z',
                92:'-570x-553y-2684z',
                93:'-597x-1872y-1994z',
                94:'-5x-385y-2773z',
                95:'-60x-2771y-390z',
                96:'-619x-540y-2676z',
                97:'-630x-954y-2555z',
                98:'-638x-2711y-279z',
                99:'-664x-2127y-1694z',
                100:'-667x-524y-2668z',
                101:'-694x-941y-2544z',
                102:'-701x-1856y-1974z',
                103:'-715x-503y-2659z',
                104:'-758x-923y-2532z',
                105:'-763x-479y-2650z',
                106:'-780x-2677y-251z',
                107:'-781x-2105y-1671z',
                108:'-805x-1835y-1954z',
                109:'-80x-461y-2760z',
                110:'-811x-452y-2641z',
                111:'-823x-900y-2520z',
                112:'-857x-420y-2632z',
                113:'-87x-1860y-2090z',
                114:'-87x-2140y-1803z',
                115:'-887x-874y-2507z',
                116:'-896x-2077y-1649z',
                117:'-902x-385y-2622z',
                118:'-909x-1808y-1934z',
                119:'-920x-2634y-223z',
                120:'-945x-346y-2612z',
                121:'-950x-843y-2495z',
                122:'-987x-304y-2602z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2800eight4xi" usage = "target function for charge2800eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2800eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2800EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2800EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2800EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2800EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2800EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight28004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2800EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2800EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2800EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight28004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight28004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2800EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2800EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2800EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2800eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  